package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import java.util.Iterator;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;
import net.minecraft.core.Vec3i;
import net.minecraft.util.RandomSource;
import javax.annotation.Nullable;
import net.minecraft.network.chat.Component;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.SimpleMenuProvider;
import net.minecraft.world.Nameable;
import net.minecraft.world.MenuProvider;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.properties.NoteBlockInstrument;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.world.level.block.EnchantmentTableBlock;

public class ApothEnchantBlock extends EnchantmentTableBlock implements IReplacementBlock
{
    protected StateDefinition<Block, BlockState> container;
    
    public ApothEnchantBlock() {
        super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283913_).m_280658_(NoteBlockInstrument.BASEDRUM).m_60999_().m_60953_(state -> 7).m_60913_(5.0f, 1200.0f));
    }
    
    @Nullable
    public MenuProvider m_7246_(final BlockState state, final Level world, final BlockPos pos) {
        final BlockEntity tileentity = world.m_7702_(pos);
        if (tileentity instanceof ApothEnchantTile) {
            final Component itextcomponent = ((Nameable)tileentity).m_5446_();
            return (MenuProvider)new SimpleMenuProvider((id, inventory, player) -> new ApothEnchantmentMenu(id, inventory, ContainerLevelAccess.m_39289_(world, pos), (ApothEnchantTile)tileentity), itextcomponent);
        }
        return null;
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return (BlockEntity)new ApothEnchantTile(pPos, pState);
    }
    
    public void m_6810_(final BlockState state, final Level world, final BlockPos pos, final BlockState newState, final boolean isMoving) {
        if (state.m_60734_() != newState.m_60734_()) {
            final BlockEntity tileentity = world.m_7702_(pos);
            if (tileentity instanceof final ApothEnchantTile apothEnchantTile) {
                Block.m_49840_(world, pos, apothEnchantTile.inv.getStackInSlot(0));
                world.m_46747_(pos);
            }
        }
    }
    
    public void _setDefaultState(final BlockState state) {
        this.m_49959_(state);
    }
    
    public void setStateContainer(final StateDefinition<Block, BlockState> container) {
        this.container = container;
    }
    
    public StateDefinition<Block, BlockState> m_49965_() {
        return (StateDefinition<Block, BlockState>)((this.container == null) ? super.m_49965_() : this.container);
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_214162_(final BlockState state, final Level level, final BlockPos pos, final RandomSource rand) {
        for (final BlockPos offset : ApothEnchantBlock.f_207902_) {
            final BlockState shelfState = level.m_8055_(pos.m_121955_((Vec3i)offset));
            ((IEnchantingBlock)shelfState.m_60734_()).spawnTableParticle(shelfState, level, rand, pos, offset);
        }
    }
}
